## lomiri-push-qml 0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(ENABLE_UBUNTU_COMPAT "Enable compatibility with Ubuntu.PushNotifications" OFF)

# Standard install paths
include(GNUInstallDirs)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(EXCLUDES tests/*|.*moc_.*.cpp FILTER tests/* moc_*.cpp)
endif()

# enable QML debugging
if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES "Debug")
    add_definitions(-DQT_QML_DEBUG)
endif()

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Quick REQUIRED)

find_package (PkgConfig)
pkg_check_modules (CONNECTIVITY REQUIRED lomiri-connectivity-qt1)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

add_subdirectory(src)

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     example/app/**.qml example/app/**.desktop.in)
list(SORT I18N_SRC_FILES)

=== debian/changelog ===
lomiri-push-qml (0.3-2) unstable; urgency=medium

  * Re-upload to unstable source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Jan 2025 15:36:34 +0100

lomiri-push-qml (0.3-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1088942).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 03 Dec 2024 12:03:58 +0100

=== debian/control ===
Source: lomiri-push-qml
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake (>= 2.8.9),
               dbus-test-runner,
               debhelper-compat (= 13),
               liblomiri-connectivity-qt1-dev,
               pkgconf,
               qml-module-qtquick2,
               qml-module-qttest,
               qml-module-lomiri-components,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               xvfb,
               xauth,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-push-qml
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-push-qml.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-push-qml

Package: qml-module-lomiri-pushnotifications
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
         qml-module-lomiri-components,
Description: Lomiri Push Notifications QML plugin
 Lomiri's Push Service is a client/server architecture that allows one to
 send notifications to the Lomiri Shell without the need of the
 targeted app being actually running.
 .
 This QML module provides means to register, receive and send push
 notifications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=1


%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_translations:
	# Override dh_translations to work around http://pad.lv/1183262.
	# Unfortunately, the default build directory is not exposed
	# (see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=601774).
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) lomiri-push-qml.pot

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-push-qml 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.9)
+cmake_minimum_required(VERSION 3.10)
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 option(ENABLE_UBUNTU_COMPAT "Enable compatibility with Ubuntu.PushNotifications" OFF)

=== src/CMakeLists.txt ===
add_subdirectory(Lomiri)
if(ENABLE_UBUNTU_COMPAT)
add_subdirectory(Ubuntu)
endif()

=== src/Lomiri/PushNotifications/CMakeLists.txt ===
project(lomiri-push-notifications-plugin)

execute_process(
    COMMAND qmake -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_INSTALL_QML
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

set(QML_IMPORT PushNotifications)
set(IMPORTS_DIR "${QT_INSTALL_QML}/Lomiri/${QML_IMPORT}")
set(PLUGIN Lomiri${QML_IMPORT})
set(PLUGIN_SRC plugin.cpp pushclient.cpp)

if(ENABLE_UBUNTU_COMPAT)
add_definitions(-DLOMIRI_PUSHNOTIFICATIONS_UBUNTU_COMPAT)
endif()

add_library(${PLUGIN} MODULE ${PLUGIN_SRC})

target_link_libraries(${PLUGIN} Qt5::Core Qt5::Gui Qt5::Qml Qt5::DBus)

include_directories(${CONNECTIVITY_INCLUDE_DIRS})
target_link_libraries(${PLUGIN} ${CONNECTIVITY_LDFLAGS})

file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir *.js)
install(TARGETS ${PLUGIN} DESTINATION ${IMPORTS_DIR})
install(FILES ${QML_FILES} DESTINATION ${IMPORTS_DIR})

add_custom_command(
    TARGET ${PLUGIN}
    POST_BUILD
    COMMAND "qmlplugindump" "Lomiri.${QML_IMPORT}" "0.1" "${CMAKE_BINARY_DIR}/src" ">" "plugins.qmltypes"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    DESTINATION ${IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files over to build dir to be able to import them uninstalled
  set(copied ${QML_FILES})
  foreach(_file ${copied})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${copied})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

=== src/Ubuntu/PushNotifications/CMakeLists.txt ===
project(ubuntu-push-notifications-plugin)

execute_process(
    COMMAND qmake -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_INSTALL_QML
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

set(QML_IMPORT PushNotifications)
set(IMPORTS_DIR "${QT_INSTALL_QML}/Ubuntu/${QML_IMPORT}")
set(PLUGIN Ubuntu${QML_IMPORT})
set(DEST_PLUGIN Lomiri${QML_IMPORT})

add_custom_target(${PLUGIN} ALL
    COMMAND ${CMAKE_COMMAND} -E create_symlink ../../Lomiri/PushNotifications/lib${DEST_PLUGIN}.so lib${PLUGIN}.so
    COMMAND ${CMAKE_COMMAND} -E create_symlink ../../Lomiri/PushNotifications/plugins.qmltypes plugins.qmltypes
)

file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir *.js)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PLUGIN}.so DESTINATION ${IMPORTS_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes DESTINATION ${IMPORTS_DIR})
install(FILES ${QML_FILES} DESTINATION ${IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files over to build dir to be able to import them uninstalled
  set(copied ${QML_FILES})
  foreach(_file ${copied})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_compat_files_to_build_dir DEPENDS ${copied})
  add_dependencies(${PLUGIN} copy_compat_files_to_build_dir)
endif()

=== debian/changelog ===
lomiri-push-qml (0.3.1-1) unstable; urgency=medium

  * New upstream release.
    - Support building with CMake 4. (Closes: #1113244).
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + Update versioned B-D on cmake.
  * debian/copyright:
    + Update FSF mailing address.
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 16:49:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
-Build-Depends: cmake (>= 2.8.9),
+Build-Depends: cmake (>= 3.10),
                dbus-test-runner,
                debhelper-compat (= 13),
                liblomiri-connectivity-qt1-dev,
@@ -17,7 +17,7 @@
                qtdeclarative5-dev-tools,
                xvfb,
                xauth,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-push-qml
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-push-qml.git
